; -=====================================================================================-
;                                     PureZIP DLL INCLUDE
;                                         For Purebasic
;                                          - UNICODE -
; -=====================================================================================-
;
; ///////////////////////////////////////////////////////////////////////////
;                     DEFINE CONSTANTS and STRUCTURES
; ///////////////////////////////////////////////////////////////////////////
;
; PureZIP constants
#_PureZIP_DontStorePath = 0
#_PureZIP_StorePathAbsolute = 1 ; store path
#_PureZIP_StorePathRelative = 2 ; store path relative to base directory
#_PureZIP_NotRecursive = 0
#_PureZIP_Recursive = 1
#_PureZIP_RecursiveZeroDirs = 2
#_PureZIP_CallbackStop = -666  
;
; ZLIB constants
#UNZ_OK                           = 0
#UNZ_END_OF_LIST_OF_FILE          = -100
#UNZ_EOF                          = 0
#UNZ_PARAMERROR                   = -102
#UNZ_BADZIPFILE                   = -103
#UNZ_INTERNALERROR                = -104
#UNZ_CRCERROR                     = -105
#Z_DEFLATED                       = 8
#Z_NO_COMPRESSION                 = 0
#Z_BEST_SPEED                     = 1
#Z_BEST_COMPRESSION               = 9
#Z_DEFAULT_COMPRESSION            = -1
#APPEND_STATUS_CREATE             = 0
#APPEND_STATUS_CREATEAFTER        = 1
#APPEND_STATUS_ADDINZIP           = 2
#Z_OK                             = 0
#Z_STREAM_END                     = 1
#Z_NEED_DICT                      = 2
#Z_ERRNO                          = -1
#Z_STREAM_ERROR                   = -2
#Z_DATA_ERROR                     = -3
#Z_MEM_ERROR                      = -4
#Z_BUF_ERROR                      = -5
#Z_VERSION_ERROR                  = -6 
#Z_FILTERED                       = 1
#Z_HUFFMAN_ONLY                   = 2
#Z_RLE                            = 3
#Z_DEFAULT_STRATEGY               = 0
;
; Structures : already defined in PureZIP.res (uncomment if needed [if you don't have PureZIP user library installed])
;
; Structure tm_date
  ; tm_sec.l  ; seconds after the minute - [0,59]
  ; tm_min.l  ; minutes after the hour - [0,59]
  ; tm_hour.l ; hours since midnight - [0,23]
  ; tm_mday.l ; day of the month - [1,31]
  ; tm_mon.l  ; months since January - [0,11]
  ; tm_year.l ; years - [1980..2044]
; EndStructure
; Structure unz_global_info
  ; number_entry.l      ; total number of entries in the zipfile
  ; size_comment.l      ; size of the global comment of the zipfile
; EndStructure
; Structure PureZIP_FileInfo
  ; Version.l           ; version made by
  ; VersionNeeded.l     ; version needed to extract
  ; flag.l              ; general purpose bit Flag
  ; CompressionMethod.l ; compression method     
  ; dosDate.l           ; last mod file date in Dos format
  ; Crc32.l             ; crc-32
  ; CompressedSize.l    ; compressed size
  ; unCompressedSize.l  ; uncompressed size
  ; SizeFilename.l      ; filename length
  ; SizeFileExtra.l     ; extra field length
  ; SizeFileComment.l   ; file comment length
  ; DiskNumStart.l      ; disk number start
  ; internal_fa.l       ; internal file attributes
  ; external_fa.l       ; external file attributes
  ; tmu_date.tm_date    ; file date (see tm_date structure)
  ; FileName.s          ; filename
; EndStructure
; Structure zip_file_info
  ; tm_zip.tm_date
  ; dosDate.l
  ; internal_fa.l
  ; external_fa.l
; EndStructure
; Structure unz_file_pos
  ; pos_in_zip_directory.l
  ; num_of_file.l
; EndStructure
;
; ///////////////////////////////////////////////////////////////////////////
;                  DECLARE SHARED LIBRARY FUNCTIONS
; ///////////////////////////////////////////////////////////////////////////
;
#UseStatic = #False
;
CompilerIf #UseStatic ;>
  ;
  ; THE STATIC WAY
  ;
  ; Import Functions from library
  ;
  Import "PureZIP_U.lib"
    PureZIPDLL_AddFile(ArchiveFileName.p-unicode, FileName.p-unicode, StorePath.l) As "_PureZIPDLL_AddFile@12"
    PureZIPDLL_AddFiles(ArchiveFileName.p-unicode, FileMask.p-unicode, StorePath.l, Recursive.l) As "_PureZIPDLL_AddFiles@16"
    PureZIPDLL_AddMemory(ArchiveFileName.p-unicode, FileName.p-unicode, *MemoryBank, MemoryBankSize.l) As "_PureZIPDLL_AddMemory@16"
    PureZIPDLL_Archive_Close() As "_PureZIPDLL_Archive_Close@0"
    PureZIPDLL_Archive_Compress(FileName.p-unicode, StorePath.l) As "_PureZIPDLL_Archive_Compress@8"
    PureZIPDLL_Archive_CompressMem(FileName.p-unicode, *MemoryBank, MemoryBankSize.l) As "_PureZIPDLL_Archive_CompressMem@12"
    PureZIPDLL_Archive_Create(ArchiveFileName.p-unicode, AppendMethod.l) As "_PureZIPDLL_Archive_Create@8"
    PureZIPDLL_Archive_Extract(OutputPath.p-unicode, ExtractPath.l) As "_PureZIPDLL_Archive_Extract@8"
    PureZIPDLL_Archive_ExtractMem(*MemoryBank, MemoryBankSize.l) As "_PureZIPDLL_Archive_ExtractMem@8"
    PureZIPDLL_Archive_FileInfo(*FileInfo.PureZIP_FileInfo) As "_PureZIPDLL_Archive_FileInfo@4"
    PureZIPDLL_Archive_FindFirst() As "_PureZIPDLL_Archive_FindFirst@0"
    PureZIPDLL_Archive_FindNext() As "_PureZIPDLL_Archive_FindNext@0"
    PureZIPDLL_Archive_GlobalInfo(*GlobalInfo.unz_global_info) As "_PureZIPDLL_Archive_GlobalInfo@4"
    PureZIPDLL_Archive_Locate(FileName.p-unicode) As "_PureZIPDLL_Archive_Locate@4"
    PureZIPDLL_Archive_Read(ArchiveFileName.p-unicode) As "_PureZIPDLL_Archive_Read@4"
    PureZIPDLL_ExtractFile(ArchiveFileName.p-unicode, FileNumberInArchive.l, OutputPath.p-unicode, ExtractPath.l) As "_PureZIPDLL_ExtractFile@16"
    PureZIPDLL_ExtractFiles(ArchiveFileName.p-unicode, FileMask.p-unicode, OutputPath.p-unicode, ExtractPath.l) As "_PureZIPDLL_ExtractFiles@16"
    PureZIPDLL_ExtractMemory(ArchiveFileName.p-unicode, FileNumberInArchive.l, *MemoryBank, MemoryBankSize.l) As "_PureZIPDLL_ExtractMemory@16"
    PureZIPDLL_FindFile(ArchiveFileName.p-unicode, FileName.p-unicode, IncludingPath = #False) As "_PureZIPDLL_FindFile2@12"
    PureZIPDLL_GetFileCount(ArchiveFileName.p-unicode) As "_PureZIPDLL_GetFileCount@4"
    PureZIPDLL_GetFileInfo(ArchiveFileName.p-unicode, FileNumberInArchive.l, *FileInfo.PureZIP_FileInfo) As "_PureZIPDLL_GetFileInfo@12"
    PureZIPDLL_PackMemory(*SourceMemoryID, SourceLength.l, *DestinationMemoryID, *DestinationLength) As "_PureZIPDLL_PackMemory@16"
    PureZIPDLL_SetArchivePassword(Password.p-unicode) As "_PureZIPDLL_SetArchivePassword@4"
    PureZIPDLL_SetCompressionAlgorithm(Algorithm.l) As "_PureZIPDLL_SetCompressionAlgorithm@4"
    PureZIPDLL_SetCompressionCallback(*ProcedureAddress) As "_PureZIPDLL_SetCompressionCallback@4"
    PureZIPDLL_SetProgressionCallback(*ProcedureAddress) As "_PureZIPDLL_SetProgressionCallback@4"
    PureZIPDLL_UnpackMemory(*SourceMemoryID, SourceLength.l, *DestinationMemoryID, *DestinationLength) As "_PureZIPDLL_UnpackMemory@16"
  EndImport
  ;
  ; or
  ;
CompilerElse ;=
  ;
  ; THE DYNAMIC WAY
  ;
  ; Define prototypes
  ;
  Prototype.l Proto_PureZIPDLL_AddFile(ArchiveFileName.p-unicode, FileName.p-unicode, StorePath.l)
  Prototype.l Proto_PureZIPDLL_AddFiles(ArchiveFileName.p-unicode, FileMask.p-unicode, StorePath.l, Recursive.l)
  Prototype.l Proto_PureZIPDLL_AddMemory(ArchiveFileName.p-unicode, FileName.p-unicode, *MemoryBank, MemoryBankSize.l)
  Prototype.l Proto_PureZIPDLL_Archive_Close()
  Prototype.l Proto_PureZIPDLL_Archive_Compress(FileName.p-unicode, StorePath.l)
  Prototype.l Proto_PureZIPDLL_Archive_CompressMem(FileName.p-unicode, *MemoryBank, MemoryBankSize.l)
  Prototype.l Proto_PureZIPDLL_Archive_Create(ArchiveFileName.p-unicode, AppendMethod.l)
  Prototype.l Proto_PureZIPDLL_Archive_Extract(OutputPath.p-unicode, ExtractPath.l)
  Prototype.l Proto_PureZIPDLL_Archive_ExtractMem(*MemoryBank, MemoryBankSize.l)
  Prototype.l Proto_PureZIPDLL_Archive_FileInfo(*FileInfo.PureZIP_FileInfo)
  Prototype.l Proto_PureZIPDLL_Archive_FindFirst()
  Prototype.l Proto_PureZIPDLL_Archive_FindNext()
  Prototype.l Proto_PureZIPDLL_Archive_GlobalInfo(*GlobalInfo.unz_global_info)
  Prototype.l Proto_PureZIPDLL_Archive_Locate(FileName.p-unicode)
  Prototype.l Proto_PureZIPDLL_Archive_Read(ArchiveFileName.p-unicode)
  Prototype.l Proto_PureZIPDLL_ExtractFile(ArchiveFileName.p-unicode, FileNumberInArchive.l, OutputPath.p-unicode, ExtractPath.l)
  Prototype.l Proto_PureZIPDLL_ExtractFiles(ArchiveFileName.p-unicode, FileMask.p-unicode, OutputPath.p-unicode, ExtractPath.l)
  Prototype.l Proto_PureZIPDLL_ExtractMemory(ArchiveFileName.p-unicode, FileNumberInArchive.l, *MemoryBank, MemoryBankSize.l)
  Prototype.l Proto_PureZIPDLL_FindFile(ArchiveFileName.p-unicode, FileName.p-unicode, IncludingPath = #False)
  Prototype.l Proto_PureZIPDLL_GetFileCount(ArchiveFileName.p-unicode)
  Prototype.l Proto_PureZIPDLL_GetFileInfo(ArchiveFileName.p-unicode, FileNumberInArchive.l, *FileInfo.PureZIP_FileInfo)
  Prototype.l Proto_PureZIPDLL_PackMemory(*SourceMemoryID, SourceLength.l, *DestinationMemoryID, *DestinationLength)
  Prototype.l Proto_PureZIPDLL_SetArchivePassword(Password.p-unicode)
  Prototype.l Proto_PureZIPDLL_SetCompressionAlgorithm(Algorithm.l)
  Prototype.l Proto_PureZIPDLL_SetCompressionCallback(*ProcedureAddress)
  Prototype.l Proto_PureZIPDLL_SetProgressionCallback(*ProcedureAddress)
  Prototype.l Proto_PureZIPDLL_UnpackMemory(*SourceMemoryID, SourceLength.l, *DestinationMemoryID, *DestinationLength)
  ;
  ; Get functions
  ;
  PureZIP = OpenLibrary(#PB_Any, "PureZIP_U.DLL")
  If PureZIP
    PureZIPDLL_AddFile.Proto_PureZIPDLL_AddFile = GetFunction(PureZIP, "PureZIPDLL_AddFile")
    PureZIPDLL_AddFiles.Proto_PureZIPDLL_AddFiles = GetFunction(PureZIP, "PureZIPDLL_AddFiles")
    PureZIPDLL_AddMemory.Proto_PureZIPDLL_AddMemory = GetFunction(PureZIP, "PureZIPDLL_AddMemory")
    PureZIPDLL_Archive_Close.Proto_PureZIPDLL_Archive_Close = GetFunction(PureZIP, "PureZIPDLL_Archive_Close")
    PureZIPDLL_Archive_Compress.Proto_PureZIPDLL_Archive_Compress = GetFunction(PureZIP, "PureZIPDLL_Archive_Compress")
    PureZIPDLL_Archive_CompressMem.Proto_PureZIPDLL_Archive_CompressMem = GetFunction(PureZIP, "PureZIPDLL_Archive_CompressMem")
    PureZIPDLL_Archive_Create.Proto_PureZIPDLL_Archive_Create = GetFunction(PureZIP, "PureZIPDLL_Archive_Create")
    PureZIPDLL_Archive_Extract.Proto_PureZIPDLL_Archive_Extract = GetFunction(PureZIP, "PureZIPDLL_Archive_Extract")
    PureZIPDLL_Archive_ExtractMem.Proto_PureZIPDLL_Archive_ExtractMem = GetFunction(PureZIP, "PureZIPDLL_Archive_ExtractMem")
    PureZIPDLL_Archive_FileInfo.Proto_PureZIPDLL_Archive_FileInfo = GetFunction(PureZIP, "PureZIPDLL_Archive_FileInfo")
    PureZIPDLL_Archive_FindFirst.Proto_PureZIPDLL_Archive_FindFirst = GetFunction(PureZIP, "PureZIPDLL_Archive_FindFirst")
    PureZIPDLL_Archive_FindNext.Proto_PureZIPDLL_Archive_FindNext = GetFunction(PureZIP, "PureZIPDLL_Archive_FindNext")
    PureZIPDLL_Archive_GlobalInfo.Proto_PureZIPDLL_Archive_GlobalInfo = GetFunction(PureZIP, "PureZIPDLL_Archive_GlobalInfo")
    PureZIPDLL_Archive_Locate.Proto_PureZIPDLL_Archive_Locate = GetFunction(PureZIP, "PureZIPDLL_Archive_Locate")
    PureZIPDLL_Archive_Read.Proto_PureZIPDLL_Archive_Read = GetFunction(PureZIP, "PureZIPDLL_Archive_Read")
    PureZIPDLL_ExtractFile.Proto_PureZIPDLL_ExtractFile = GetFunction(PureZIP, "PureZIPDLL_ExtractFile")
    PureZIPDLL_ExtractFiles.Proto_PureZIPDLL_ExtractFiles = GetFunction(PureZIP, "PureZIPDLL_ExtractFiles")
    PureZIPDLL_ExtractMemory.Proto_PureZIPDLL_ExtractMemory = GetFunction(PureZIP, "PureZIPDLL_ExtractMemory")
    PureZIPDLL_FindFile.Proto_PureZIPDLL_FindFile = GetFunction(PureZIP, "PureZIPDLL_FindFile2")
    PureZIPDLL_GetFileCount.Proto_PureZIPDLL_GetFileCount = GetFunction(PureZIP, "PureZIPDLL_GetFileCount")
    PureZIPDLL_GetFileInfo.Proto_PureZIPDLL_GetFileInfo = GetFunction(PureZIP, "PureZIPDLL_GetFileInfo")
    PureZIPDLL_PackMemory.Proto_PureZIPDLL_PackMemory = GetFunction(PureZIP, "PureZIPDLL_PackMemory")
    PureZIPDLL_SetArchivePassword.Proto_PureZIPDLL_SetArchivePassword = GetFunction(PureZIP, "PureZIPDLL_SetArchivePassword")
    PureZIPDLL_SetCompressionAlgorithm.Proto_PureZIPDLL_SetCompressionAlgorithm = GetFunction(PureZIP, "PureZIPDLL_SetCompressionAlgorithm")
    PureZIPDLL_SetCompressionCallback.Proto_PureZIPDLL_SetCompressionCallback = GetFunction(PureZIP, "PureZIPDLL_SetCompressionCallback")
    PureZIPDLL_SetProgressionCallback.Proto_PureZIPDLL_SetProgressionCallback = GetFunction(PureZIP, "PureZIPDLL_SetProgressionCallback")
    PureZIPDLL_UnpackMemory.Proto_PureZIPDLL_UnpackMemory = GetFunction(PureZIP, "PureZIPDLL_UnpackMemory")
  Else
    End
  EndIf
CompilerEndIf ;<
;
; ///////////////////////////////////////////////////////////////////////////
;